"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Dropdown = void 0;

var _react = _interopRequireWildcard(require("react"));

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _ = require(".");

var _GlobalListeners = require("./HOC/GlobalListeners");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var DropdownBase =
/*#__PURE__*/
function (_Component) {
  _inherits(DropdownBase, _Component);

  var _super = _createSuper(DropdownBase);

  // declare ref types
  // define static properties
  function DropdownBase(props) {
    var _this;

    _classCallCheck(this, DropdownBase);

    _this = _super.call(this, props); // define ref

    _defineProperty(_assertThisInitialized(_this), "rootElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "optionsElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "isOpen", function () {
      var _this$props = _this.props,
          clickToOpen = _this$props.clickToOpen,
          isOpen = _this$props.isOpen;
      var _this$state = _this.state,
          isMouseOverItems = _this$state.isMouseOverItems,
          isMouseOverRoot = _this$state.isMouseOverRoot;
      var isOpenBecauseOfHover = clickToOpen ? false : isMouseOverItems || isMouseOverRoot;
      return isOpen || _this.state.isOpen || isOpenBecauseOfHover;
    });

    _defineProperty(_assertThisInitialized(_this), "toggleOpen", function () {
      if (_this.isOpen()) {
        _this.close();
      } else {
        _this.setState({
          isOpen: true
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "close", function () {
      _this._setMouseOverRoot(false);

      _this._setMouseOverItems(false);

      _this.setState({
        isOpen: false
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_setMouseOverItems", function (isMouseOverItems) {
      _this.setState({
        isMouseOverItems: isMouseOverItems
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_setMouseOverRoot", function (isMouseOverRoot) {
      _this.setState({
        isMouseOverRoot: isMouseOverRoot
      });
    });

    _defineProperty(_assertThisInitialized(_this), "_onItemSelected", function (item) {
      var onItemSelected = _this.props.onItemSelected;

      _this.close();

      if (onItemSelected) {
        onItemSelected(item);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_onLabelClick", function () {
      if (_this.props.clickToOpen) {
        _this.toggleOpen();
      }
    });

    _this.rootElement =
    /*#__PURE__*/
    _react["default"].createRef();
    _this.optionsElement =
    /*#__PURE__*/
    _react["default"].createRef();
    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API),
      isMouseOverItems: false,
      isMouseOverRoot: false,
      isOpen: false
    };
    return _this;
  }

  _createClass(DropdownBase, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      this.close();
    } // ========= PUBLIC SKIN API =========

  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props2 = this.props,
          clickToOpen = _this$props2.clickToOpen,
          context = _this$props2.context,
          isOpen = _this$props2.isOpen,
          isOpeningUpward = _this$props2.isOpeningUpward,
          onItemSelected = _this$props2.onItemSelected,
          skin = _this$props2.skin,
          theme = _this$props2.theme,
          themeOverrides = _this$props2.themeOverrides,
          rest = _objectWithoutProperties(_this$props2, ["clickToOpen", "context", "isOpen", "isOpeningUpward", "onItemSelected", "skin", "theme", "themeOverrides"]);

      var DropdownSkin = skin || context.skins[_.IDENTIFIERS.DROPDOWN];
      var _this$state2 = this.state,
          isMouseOverItems = _this$state2.isMouseOverItems,
          isMouseOverRoot = _this$state2.isMouseOverRoot;
      return (
        /*#__PURE__*/
        _react["default"].createElement(_GlobalListeners.GlobalListeners, {
          mouseIsOverOptions: isMouseOverItems,
          mouseIsOverRoot: isMouseOverRoot,
          optionsIsOpen: this.isOpen(),
          optionsIsOpeningUpward: isOpeningUpward,
          optionsRef: this.optionsElement,
          rootRef: this.rootElement,
          toggleOpen: this.toggleOpen
        }, function (_ref) {
          var optionsMaxHeight = _ref.optionsMaxHeight,
              optionHeight = _ref.optionHeight;
          return (
            /*#__PURE__*/
            _react["default"].createElement(DropdownSkin, _extends({
              isOpen: _this2.isOpen(),
              isOpeningUpward: isOpeningUpward,
              onItemSelected: _this2._onItemSelected,
              onLabelClick: _this2._onLabelClick,
              optionsRef: _this2.optionsElement,
              optionsMaxHeight: optionsMaxHeight,
              optionHeight: optionHeight,
              rootRef: _this2.rootElement,
              setMouseOverItems: _this2._setMouseOverItems,
              setMouseOverRoot: _this2._setMouseOverRoot,
              theme: _this2.state.composedTheme
            }, rest))
          );
        })
      );
    }
  }]);

  return DropdownBase;
}(_react.Component);

_defineProperty(DropdownBase, "displayName", 'Dropdown');

_defineProperty(DropdownBase, "defaultProps", {
  context: (0, _withTheme.createEmptyContext)(),
  clickToOpen: false,
  isOpeningUpward: false,
  noArrow: false,
  theme: null,
  themeOverrides: {},
  themeId: _.IDENTIFIERS.DROPDOWN
});

var Dropdown = (0, _withTheme.withTheme)(DropdownBase);
exports.Dropdown = Dropdown;
//# sourceMappingURL=Dropdown.js.map