"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormField = void 0;

var _react = _interopRequireWildcard(require("react"));

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _ = require(".");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var FormFieldBase =
/*#__PURE__*/
function (_Component) {
  _inherits(FormFieldBase, _Component);

  var _super = _createSuper(FormFieldBase);

  // define static properties
  function FormFieldBase(props) {
    var _props$formFieldRef;

    var _this;

    _classCallCheck(this, FormFieldBase);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "formFieldRef", void 0);

    _defineProperty(_assertThisInitialized(_this), "setError", function (error) {
      return _this.setState({
        error: error
      });
    });

    _defineProperty(_assertThisInitialized(_this), "focusChild", function () {
      var _assertThisInitialize = _assertThisInitialized(_this),
          formFieldRef = _assertThisInitialize.formFieldRef;

      if (formFieldRef && formFieldRef.current) {
        if (typeof formFieldRef.current.focus === 'function') {
          formFieldRef.current.focus();
        }
      }
    });

    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.formFieldRef = (_props$formFieldRef = props.formFieldRef) !== null && _props$formFieldRef !== void 0 ? _props$formFieldRef :
    /*#__PURE__*/
    _react["default"].createRef();
    _this.state = {
      error: '',
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API)
    };
    return _this;
  }

  _createClass(FormFieldBase, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    }
  }, {
    key: "render",
    value: function render() {
      // destructuring props ensures only the "...rest" get passed down
      var _this$props = this.props,
          skin = _this$props.skin,
          theme = _this$props.theme,
          themeOverrides = _this$props.themeOverrides,
          error = _this$props.error,
          context = _this$props.context,
          rest = _objectWithoutProperties(_this$props, ["skin", "theme", "themeOverrides", "error", "context"]);

      var FormFieldSkin = skin || context.skins[_.IDENTIFIERS.FORM_FIELD];
      return (
        /*#__PURE__*/
        _react["default"].createElement(FormFieldSkin, _extends({
          error: error || this.state.error,
          setError: this.setError,
          theme: this.state.composedTheme,
          formFieldRef: this.formFieldRef,
          focusChild: this.focusChild
        }, rest))
      );
    }
  }]);

  return FormFieldBase;
}(_react.Component);

_defineProperty(FormFieldBase, "displayName", 'FormField');

_defineProperty(FormFieldBase, "defaultProps", {
  context: (0, _withTheme.createEmptyContext)(),
  isShowingErrorOnFocus: true,
  isShowingErrorOnHover: true,
  theme: null,
  themeId: _.IDENTIFIERS.FORM_FIELD,
  themeOverrides: {}
});

var FormField = (0, _withTheme.withTheme)(FormFieldBase);
exports.FormField = FormField;
//# sourceMappingURL=FormField.js.map