"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ThemeContext = void 0;

var _react = _interopRequireDefault(require("react"));

var _createReactContext = _interopRequireDefault(require("create-react-context"));

var _API = require("../../themes/API");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// components that are NOT directly nested within a ThemeProvider
// can access simple theme as "this.props.context.theme",
// same goes for "this.props.context.ROOT_THEME_API"
// if the user passes ThemeProvider a theme and/or ROOT_THEME_API,
// these default values are overwritten
// check to use context pollyfill or not
var createContext;

if (_react["default"].createContext) {
  // React module contains createContext method, no polyfill
  createContext = _react["default"].createContext;
} else {
  // use create-react-context polyfill
  createContext = _createReactContext["default"];
}

var defaultContext = {
  skins: {},
  theme: _API.ROOT_THEME_API,
  ROOT_THEME_API: _API.ROOT_THEME_API
};
var ThemeContext = createContext(defaultContext);
exports.ThemeContext = ThemeContext;
//# sourceMappingURL=ThemeContext.js.map