"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Header = void 0;

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _pickBy2 = _interopRequireDefault(require("lodash/pickBy"));

var _react = _interopRequireWildcard(require("react"));

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _ = require(".");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var HeaderBase =
/*#__PURE__*/
function (_Component) {
  _inherits(HeaderBase, _Component);

  var _super = _createSuper(HeaderBase);

  // define static properties
  function HeaderBase(props) {
    var _this;

    _classCallCheck(this, HeaderBase);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "_assembleInlineStyles", function (_ref) {
      var center = _ref.center,
          lowerCase = _ref.lowerCase,
          left = _ref.left,
          right = _ref.right,
          upperCase = _ref.upperCase;
      var inlineStyles = {};
      var textAlign = (0, _pickBy2["default"])({
        center: center,
        left: left,
        right: right
      });
      var textTransform = (0, _pickBy2["default"])({
        lowerCase: lowerCase,
        upperCase: upperCase
      });

      if (!(0, _isEmpty2["default"])(textAlign)) {
        inlineStyles.textAlign = Object.keys(textAlign)[0];
      }

      if (!(0, _isEmpty2["default"])(textTransform)) {
        inlineStyles.textTransform = Object.keys(textTransform)[0];
      }

      return inlineStyles;
    });

    _defineProperty(_assertThisInitialized(_this), "_assembleHeaderTheme", function (styleProps) {
      var activeClasses = _this._getActiveClasses(styleProps);

      var theme = _this.state.composedTheme[_this.props.themeId];
      return activeClasses.reduce(function (reducedTheme, activeClass) {
        if (activeClass && Object.hasOwnProperty.call(theme, activeClass)) {
          reducedTheme[activeClass] = theme[activeClass];
        }

        return reducedTheme;
      }, {});
    });

    _defineProperty(_assertThisInitialized(_this), "_getActiveFont", function (_ref2) {
      var light = _ref2.light,
          medium = _ref2.medium,
          regular = _ref2.regular,
          thin = _ref2.thin,
          bold = _ref2.bold;
      var fontProps = (0, _pickBy2["default"])({
        light: light,
        medium: medium,
        regular: regular,
        thin: thin,
        bold: bold
      });

      if ((0, _isEmpty2["default"])(fontProps)) {
        return;
      } // returns the first active font if more than 1 is passed


      return Object.keys(fontProps)[0];
    });

    _defineProperty(_assertThisInitialized(_this), "_getActiveTheme", function (_ref3) {
      var h1 = _ref3.h1,
          h2 = _ref3.h2,
          h3 = _ref3.h3,
          h4 = _ref3.h4;
      var themeProps = (0, _pickBy2["default"])({
        h1: h1,
        h2: h2,
        h3: h3,
        h4: h4
      });

      if ((0, _isEmpty2["default"])(themeProps)) {
        return;
      } // returns the first active theme if more than 1 is passed


      return Object.keys(themeProps)[0];
    });

    _defineProperty(_assertThisInitialized(_this), "_getActiveClasses", function (styleProps) {
      var activeClasses = ['header'];

      var activeTheme = _this._getActiveTheme(styleProps);

      var activeFont = _this._getActiveFont(styleProps);

      if (activeTheme) {
        return [].concat(activeClasses, [activeTheme]);
      }

      if (activeFont) {
        return [].concat(activeClasses, [activeFont]);
      }

      return [].concat(activeClasses, [activeTheme, activeFont]).filter(function (val) {
        return val;
      });
    });

    var context = props.context,
        themeId = props.themeId,
        _theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(_theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API)
    };
    return _this;
  }

  _createClass(HeaderBase, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          skin = _this$props.skin,
          context = _this$props.context,
          styleProps = _objectWithoutProperties(_this$props, ["children", "className", "skin", "context"]);

      var HeaderSkin = skin || context.skins[_.IDENTIFIERS.HEADER];

      var reducedTheme = this._assembleHeaderTheme(styleProps);

      var inlineStyles = this._assembleInlineStyles(styleProps);

      return (
        /*#__PURE__*/
        _react["default"].createElement(HeaderSkin, {
          className: className,
          inlineStyles: inlineStyles,
          theme: reducedTheme
        }, children)
      );
    }
  }]);

  return HeaderBase;
}(_react.Component);

_defineProperty(HeaderBase, "displayName", 'Header');

_defineProperty(HeaderBase, "defaultProps", {
  context: (0, _withTheme.createEmptyContext)(),
  theme: null,
  themeId: _.IDENTIFIERS.HEADER,
  themeOverrides: {}
});

var Header = (0, _withTheme.withTheme)(HeaderBase);
exports.Header = Header;
//# sourceMappingURL=Header.js.map