"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Options = void 0;

var _escapeRegExp2 = _interopRequireDefault(require("lodash/escapeRegExp"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _react = _interopRequireWildcard(require("react"));

var _withTheme = require("./HOC/withTheme");

var _themes = require("../utils/themes");

var _props = require("../utils/props");

var _ = require(".");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var OptionsBase =
/*#__PURE__*/
function (_Component) {
  _inherits(OptionsBase, _Component);

  var _super = _createSuper(OptionsBase);

  // declare ref types
  // TODO: Does this get used? Don't think so.
  // define static properties
  function OptionsBase(props) {
    var _this;

    _classCallCheck(this, OptionsBase);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "optionsElement", void 0);

    _defineProperty(_assertThisInitialized(_this), "setupOnOpenListeners", function () {
      document.addEventListener('keydown', _this._handleKeyDown, false);
      var input = _this.searchInputRef.current;

      if (input) {
        input.focus && input.focus();
        input.select && input.select();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "setupOnCloseListeners", function () {
      document.removeEventListener('keydown', _this._handleKeyDown, false);
    });

    _defineProperty(_assertThisInitialized(_this), "close", function () {
      var _this$props = _this.props,
          isOpen = _this$props.isOpen,
          onClose = _this$props.onClose,
          resetOnClose = _this$props.resetOnClose,
          toggleOpen = _this$props.toggleOpen;
      if (isOpen && toggleOpen) toggleOpen();

      _this.setState({
        highlightedOptionIndex: resetOnClose ? 0 : _this.state.highlightedOptionIndex
      });

      if (onClose) onClose();
    });

    _defineProperty(_assertThisInitialized(_this), "getHighlightedOptionIndex", function () {
      // If nothing is higlighted, highlight selected option
      // In case nothing is selected, highlight first option
      var _this$props2 = _this.props,
          options = _this$props2.options,
          isOpeningUpward = _this$props2.isOpeningUpward;
      var currentIndex = _this.state.highlightedOptionIndex;
      var index = 0;

      if (currentIndex !== null) {
        index = currentIndex;
      }

      if (isOpeningUpward) return options.length - 1 - index;
      return index;
    });

    _defineProperty(_assertThisInitialized(_this), "setHighlightedOptionIndex", function (optionIndex) {
      if (!_this.isHighlightedOption(optionIndex) && _this.isDisabledOption(optionIndex)) {
        _this.setState({
          highlightedOptionIndex: optionIndex
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "isSelectedOption", function (optionIndex) {
      var _this$props3 = _this.props,
          options = _this$props3.options,
          isOpeningUpward = _this$props3.isOpeningUpward;
      var index = isOpeningUpward ? options.length - 1 - optionIndex : optionIndex;
      var option = options[index];
      return option && _this.props.selectedOption === option;
    });

    _defineProperty(_assertThisInitialized(_this), "isHighlightedOption", function (optionIndex) {
      return _this.state.highlightedOptionIndex === optionIndex;
    });

    _defineProperty(_assertThisInitialized(_this), "isDisabledOption", function (optionIndex) {
      var options = _this.props.options;
      var option = options[optionIndex];
      return option && !option.isDisabled;
    });

    _defineProperty(_assertThisInitialized(_this), "handleClickOnOption", function (option, event) {
      if (option) {
        if (option.isDisabled) return;
        if (_this.props.onChange) _this.props.onChange(option, event);
      }

      if (_this.props.onBlur) _this.props.onBlur(event);

      _this.close();
    });

    _defineProperty(_assertThisInitialized(_this), "handleSearch", function (searchValue) {
      _this.setState({
        searchValue: searchValue
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleClearSearchValue", function () {
      _this.setState({
        searchValue: ''
      });
    });

    _defineProperty(_assertThisInitialized(_this), "getFilteredOptions", function () {
      var _this$props4 = _this.props,
          hasSearch = _this$props4.hasSearch,
          onSearch = _this$props4.onSearch,
          options = _this$props4.options,
          highlightSearch = _this$props4.highlightSearch,
          optionRenderer = _this$props4.optionRenderer;
      var searchValue = _this.state.searchValue;

      if (!hasSearch || !searchValue) {
        return options;
      }

      if (hasSearch && (0, _isFunction2["default"])(onSearch)) {
        return onSearch(searchValue, options);
      }

      var filteredOptions = options.filter(function (option) {
        var label = option.label;
        var regex = new RegExp((0, _escapeRegExp2["default"])(searchValue), 'i');
        return regex.test(label);
      });
      return filteredOptions;
    });

    _defineProperty(_assertThisInitialized(_this), "getOptionProps", function () {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _onClick = _ref.onClick,
          _onMouseEnter = _ref.onMouseEnter,
          rest = _objectWithoutProperties(_ref, ["onClick", "onMouseEnter"]);

      var _this$props5 = _this.props,
          isOpen = _this$props5.isOpen,
          themeId = _this$props5.themeId,
          options = _this$props5.options,
          selectedOptions = _this$props5.selectedOptions;
      var composedTheme = _this.state.composedTheme;

      var _assertThisInitialize = _assertThisInitialized(_this),
          isHighlightedOption = _assertThisInitialize.isHighlightedOption,
          isDisabledOption = _assertThisInitialize.isDisabledOption,
          handleClickOnOption = _assertThisInitialize.handleClickOnOption,
          setHighlightedOptionIndex = _assertThisInitialize.setHighlightedOptionIndex;

      return _objectSpread({
        options: options,
        selectedOptions: selectedOptions,
        isOpen: isOpen,
        isHighlightedOption: isHighlightedOption,
        isDisabledOption: isDisabledOption,
        theme: composedTheme[themeId],
        onClick: function onClick(option, event) {
          return (// the user's custom onClick event handler is composed with
            // the internal functionality of Options (this.handleClickOnOption)
            (0, _props.composeFunctions)(_onClick, handleClickOnOption)(option, event)
          );
        },
        onMouseEnter: function onMouseEnter(index, event) {
          return (// user's custom onMouseEnter is composed with this.setHighlightedOptionIndex
            (0, _props.composeFunctions)(_onMouseEnter, setHighlightedOptionIndex)(index, event)
          );
        }
      }, rest);
    });

    _defineProperty(_assertThisInitialized(_this), "getNoResults", function () {
      var _this$props6 = _this.props,
          noResults = _this$props6.noResults,
          hasSearch = _this$props6.hasSearch;

      var options = _this.getFilteredOptions();

      return noResults || hasSearch && !options.length;
    });

    _defineProperty(_assertThisInitialized(_this), "_handleSelectionOnKeyDown", function (event) {
      var options = _this.getFilteredOptions();

      if (options.length) {
        var isOpeningUpward = _this.props.isOpeningUpward;
        var currentIndex = _this.state.highlightedOptionIndex;
        var reverseIndex = options.length - 1 - currentIndex;
        var highlightedOption = options[isOpeningUpward ? reverseIndex : currentIndex];

        _this.handleClickOnOption(highlightedOption, event);
      } else {
        event.preventDefault();
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_handleHighlightMove", function (currentIndex, direction) {
      var options = _this.props.options;

      if (options.length) {
        var lowerIndexBound = 0;
        var upperIndexBound = options.length - 1;
        var newIndex = direction === 'up' ? currentIndex - 1 : currentIndex + 1; // Make sure new index is within options bounds

        newIndex = Math.max(lowerIndexBound, Math.min(newIndex, upperIndexBound));

        if (options[newIndex].isDisabled) {
          // Try to jump over disabled options
          var canMoveUp = newIndex > lowerIndexBound;
          var canMoveDown = newIndex < upperIndexBound;

          if (direction === 'up' && canMoveUp || direction === 'down' && canMoveDown) {
            _this._handleHighlightMove(newIndex, direction);
          }
        } else {
          _this.setHighlightedOptionIndex(newIndex);
        }
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_handleKeyDown", function (event) {
      var targetTagName = (0, _get2["default"])(event, 'target.tagName');
      var highlightOptionIndex = _this.state.highlightedOptionIndex;

      switch (event.keyCode) {
        case 9:
          // Tab key: selects currently highlighted option
          event.preventDefault();

          _this._handleSelectionOnKeyDown(event);

          break;

        case 13:
          // Enter key: selects currently highlighted option
          event.preventDefault();

          _this._handleSelectionOnKeyDown(event);

          break;

        case 32:
          // Space key: selects currently highlighted option
          if (targetTagName !== 'INPUT') {
            event.preventDefault();

            _this._handleSelectionOnKeyDown(event);
          }

          break;

        case 27:
          // Escape key: closes options if open
          _this.close();

          break;

        case 38:
          // Up Arrow key: moves highlighted selection 'up' 1 index
          event.preventDefault(); // prevent caret move

          _this._handleHighlightMove(highlightOptionIndex, 'up');

          break;

        case 40:
          // Down Arrow key: moves highlighted selection 'down' 1 index
          event.preventDefault(); // prevent caret move

          _this._handleHighlightMove(highlightOptionIndex, 'down');

          break;

        default:
          _this.props.resetOnClose && _this.setHighlightedOptionIndex(0);
      }
    });

    _defineProperty(_assertThisInitialized(_this), "_setMouseIsOverOptions", function (isMouseOverOptions) {
      var _this$props7 = _this.props,
          toggleMouseLocation = _this$props7.toggleMouseLocation,
          setMouseIsOverOptions = _this$props7.setMouseIsOverOptions;

      if (_this.state.isMouseOverOptions !== isMouseOverOptions && toggleMouseLocation) {
        toggleMouseLocation();
      }

      if (setMouseIsOverOptions) {
        setMouseIsOverOptions(isMouseOverOptions);
      }

      _this.setState({
        isMouseOverOptions: isMouseOverOptions
      });
    });

    var context = props.context,
        _themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.searchInputRef =
    /*#__PURE__*/
    _react["default"].createRef();
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, _themeId), (0, _themes.addThemeId)(themeOverrides, _themeId), context.ROOT_THEME_API),
      highlightedOptionIndex: 0,
      isMouseOverOptions: false
    };
    return _this;
  }

  _createClass(OptionsBase, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      if (this.props.isOpen) {
        document.addEventListener('keydown', this._handleKeyDown, false);
      }
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        if (!prevProps.isOpen && this.props.isOpen) {
          this.setupOnOpenListeners();
        } else if (prevProps.isOpen && !this.props.isOpen) {
          this.setupOnCloseListeners();
        }

        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      document.removeEventListener('keydown', this._handleKeyDown, false);
    }
  }, {
    key: "render",
    value: function render() {
      // destructuring props ensures only the "...rest" get passed down
      var _this$props8 = this.props,
          highlightSearch = _this$props8.highlightSearch,
          skin = _this$props8.skin,
          targetRef = _this$props8.targetRef,
          theme = _this$props8.theme,
          themeOverrides = _this$props8.themeOverrides,
          toggleMouseLocation = _this$props8.toggleMouseLocation,
          noResults = _this$props8.noResults,
          onChange = _this$props8.onChange,
          onSearch = _this$props8.onSearch,
          options = _this$props8.options,
          context = _this$props8.context,
          optionsRef = _this$props8.optionsRef,
          isOpen = _this$props8.isOpen,
          rest = _objectWithoutProperties(_this$props8, ["highlightSearch", "skin", "targetRef", "theme", "themeOverrides", "toggleMouseLocation", "noResults", "onChange", "onSearch", "options", "context", "optionsRef", "isOpen"]);

      var _this$state = this.state,
          composedTheme = _this$state.composedTheme,
          highlightedOptionIndex = _this$state.highlightedOptionIndex,
          searchValue = _this$state.searchValue;
      var OptionsSkin = skin || context.skins[_.IDENTIFIERS.OPTIONS];
      return (
        /*#__PURE__*/
        _react["default"].createElement(OptionsSkin, _extends({
          getHighlightedOptionIndex: this.getHighlightedOptionIndex,
          getOptionProps: this.getOptionProps,
          handleClickOnOption: this.handleClickOnOption,
          highlightSearch: highlightSearch,
          highlightedOptionIndex: highlightedOptionIndex,
          isHighlightedOption: this.isHighlightedOption,
          isOpen: isOpen,
          isSelectedOption: this.isSelectedOption,
          options: this.getFilteredOptions(),
          optionsRef: optionsRef,
          onClearSearchValue: this.handleClearSearchValue,
          searchInputRef: this.searchInputRef,
          searchValue: searchValue,
          setHighlightedOptionIndex: this.setHighlightedOptionIndex,
          targetRef: targetRef,
          theme: composedTheme,
          setMouseIsOverOptions: this._setMouseIsOverOptions,
          onSearch: this.handleSearch,
          noResults: this.getNoResults()
        }, rest))
      );
    }
  }]);

  return OptionsBase;
}(_react.Component);

_defineProperty(OptionsBase, "displayName", 'Options');

_defineProperty(OptionsBase, "defaultProps", {
  context: (0, _withTheme.createEmptyContext)(),
  isOpen: false,
  isOpeningUpward: false,
  noOptionsArrow: false,
  noOptionsCheckmark: false,
  noResultsMessage: 'No results',
  optionHeight: 46,
  options: [],
  resetOnClose: false,
  searchHeight: 52,
  theme: null,
  themeId: _.IDENTIFIERS.OPTIONS,
  themeOverrides: {},
  toggleOpen: function toggleOpen() {}
});

var Options = (0, _withTheme.withTheme)(OptionsBase);
exports.Options = Options;
//# sourceMappingURL=Options.js.map