"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PopOver = PopOver;

var _popper = require("popper.js");

var _react = _interopRequireWildcard(require("react"));

var _themes = require("../utils/themes");

var _ThemeContext = require("./HOC/ThemeContext");

var _index = require("./index");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function PopOver(props) {
  var context = props.context,
      skin = props.skin,
      theme = props.theme,
      themeId = props.themeId,
      themeOverrides = props.themeOverrides; // Theme

  var themeContext = context || (0, _react.useContext)(_ThemeContext.ThemeContext);

  if (!themeContext) {
    throw new Error('No theming context provided.');
  }

  var composedTheme = (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || themeContext.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), themeContext.ROOT_THEME_API); // Skin

  var PopOverSkin = skin || themeContext.skins[_index.IDENTIFIERS.POP_OVER];
  return (
    /*#__PURE__*/
    _react["default"].createElement(PopOverSkin, _extends({}, props, {
      theme: composedTheme
    }))
  );
}

PopOver.defaultProps = {
  allowHTML: false,
  theme: null,
  themeId: _index.IDENTIFIERS.POP_OVER,
  themeOverrides: {},
  themeVariables: {},
  popperOptions: {}
};
//# sourceMappingURL=PopOver.js.map