"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ThemeProvider = void 0;

var _cloneDeep2 = _interopRequireDefault(require("lodash/cloneDeep"));

var _isEqual2 = _interopRequireDefault(require("lodash/isEqual"));

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _react = _interopRequireWildcard(require("react"));

var _ThemeContext = require("./HOC/ThemeContext");

var _API = require("../themes/API");

var _themes = require("../utils/themes");

var _props = require("../utils/props");

var _ThemeVariablesProvider = require("./ThemeVariablesProvider");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var ThemeProvider =
/*#__PURE__*/
function (_Component) {
  _inherits(ThemeProvider, _Component);

  var _super = _createSuper(ThemeProvider);

  function ThemeProvider(props) {
    var _this;

    _classCallCheck(this, ThemeProvider);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "_composeLibraryTheme", function (theme, themeOverrides) {
      // if themeOverrides is empty, no need for composition
      if ((0, _isEmpty2["default"])(themeOverrides)) {
        return theme;
      } // final object to be returned


      var composedTheme = {};

      for (var componentName in _API.ROOT_THEME_API) {
        // check if ROOT_THEME_API contains the key of componentName
        if ((0, _props.hasProperty)(_API.ROOT_THEME_API, componentName)) {
          // check if theme contains a key of componentName
          if ((0, _props.hasProperty)(theme, componentName)) {
            // add componentName as a key to final return obj
            composedTheme[componentName] = theme[componentName];
          } // also check if themeOverrides contains the key componentName


          if ((0, _props.hasProperty)(themeOverrides, componentName)) {
            // compose theme styles with user's themeOverrides
            composedTheme[componentName] = _this._applyThemeOverrides(theme[componentName], themeOverrides[componentName], _API.ROOT_THEME_API[componentName]);
          }
        }
      }

      return composedTheme;
    });

    _defineProperty(_assertThisInitialized(_this), "_applyThemeOverrides", function (componentTheme, componentThemeOverrides, componentThemeAPI) {
      // Return componentTheme if there are no overrides provided
      if ((0, _isEmpty2["default"])(componentThemeOverrides)) {
        return componentTheme;
      } // final composed theme obj to be returned at end


      var composedComponentTheme = (0, _cloneDeep2["default"])(componentThemeAPI);

      for (var className in componentThemeAPI) {
        if ((0, _props.hasProperty)(componentThemeAPI, className)) {
          if ((0, _props.hasProperty)(componentTheme, className)) {
            (0, _themes.appendToProperty)(composedComponentTheme, className, componentTheme[className]);
          }

          if ((0, _props.hasProperty)(componentThemeOverrides, className)) {
            (0, _themes.appendToProperty)(composedComponentTheme, className, componentThemeOverrides[className]);
          }
        }
      }

      return composedComponentTheme;
    });

    var _theme = props.theme,
        _themeOverrides = props.themeOverrides;
    _this.state = {
      theme: _this._composeLibraryTheme(_theme, _themeOverrides)
    };
    return _this;
  }

  _createClass(ThemeProvider, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      var prevTheme = prevProps.theme,
          prevThemeOverrides = prevProps.themeOverrides;
      var _this$props = this.props,
          theme = _this$props.theme,
          themeOverrides = _this$props.themeOverrides;

      if (!(0, _isEqual2["default"])(prevTheme, theme) || !(0, _isEqual2["default"])(prevThemeOverrides, themeOverrides)) {
        this.setState(function () {
          return {
            theme: _this2._composeLibraryTheme(theme, themeOverrides)
          };
        });
      }
    } // composeLibraryTheme returns a single obj containing theme definitions
    // for every component in the library. Every key on the returned obj is named
    // in conjunction with a component in the library and each key's value is structured
    // to contain the css definitions for each element in that component.
    // Which is just a string via CSS-Modules. Looks like this:
    // {
    //   button: { root: '', disabled: '' },
    //   input: { input: '', disabled: '', error: '' },
    //   formField: { root: '', label: '', error: '' },
    //   ... and so on, creating a complete theme for the library,
    //  }

  }, {
    key: "render",
    value: function render() {
      var theme = this.state.theme;
      var _this$props2 = this.props,
          isRoot = _this$props2.isRoot,
          skins = _this$props2.skins,
          variables = _this$props2.variables;
      var providerState = {
        skins: skins,
        theme: theme,
        ROOT_THEME_API: _API.ROOT_THEME_API
      };
      return (
        /*#__PURE__*/
        _react["default"].createElement(_ThemeContext.ThemeContext.Provider, {
          value: providerState
        },
        /*#__PURE__*/
        _react["default"].createElement(_ThemeVariablesProvider.ThemeVariablesProvider, {
          isRoot: isRoot,
          variables: variables
        }, this.props.children))
      );
    }
  }]);

  return ThemeProvider;
}(_react.Component);

exports.ThemeProvider = ThemeProvider;
ThemeProvider.defaultProps = {
  isRoot: true,
  skins: {},
  theme: {},
  variables: {},
  themeOverrides: {}
};
//# sourceMappingURL=ThemeProvider.js.map