"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Grid = void 0;

var _isEmpty2 = _interopRequireDefault(require("lodash/isEmpty"));

var _pickBy2 = _interopRequireDefault(require("lodash/pickBy"));

var _react = _interopRequireWildcard(require("react"));

var _Base = require("./Base");

var _withTheme = require("../HOC/withTheme");

var _props = require("../../utils/props");

var _layout = require("../../utils/layout");

var _themes = require("../../utils/themes");

var _ = require("..");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) {
  function isNativeReflectConstruct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;

    try {
      Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
      return true;
    } catch (e) {
      return false;
    }
  }

  return function () {
    var Super = _getPrototypeOf(Derived),
        result;

    if (isNativeReflectConstruct()) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var GridBase =
/*#__PURE__*/
function (_Component) {
  _inherits(GridBase, _Component);

  var _super = _createSuper(GridBase);

  // define static properties
  function GridBase(props) {
    var _this;

    _classCallCheck(this, GridBase);

    _this = _super.call(this, props);

    _defineProperty(_assertThisInitialized(_this), "_assembleInlineGrid", function () {
      var _this$props = _this.props,
          className = _this$props.className,
          gridProps = _objectWithoutProperties(_this$props, ["className"]); // return early if gridProps are empty


      if ((0, _isEmpty2["default"])((0, _pickBy2["default"])(_objectSpread({}, gridProps)))) {
        return;
      }

      var alignItems = gridProps.alignItems,
          autoColumns = gridProps.autoColumns,
          autoRows = gridProps.autoRows,
          center = gridProps.center,
          columnGap = gridProps.columnGap,
          columns = gridProps.columns,
          gap = gridProps.gap,
          justifyItems = gridProps.justifyItems,
          rowGap = gridProps.rowGap,
          rows = gridProps.rows,
          template = gridProps.template,
          templateAreas = gridProps.templateAreas; // obj with correct css grid class names

      var inlineClasses = {
        alignItems: center ? 'center' : alignItems,
        gridAutoColumns: autoColumns,
        gridAutoRows: autoRows,
        gridTemplateColumns: columns,
        gridTemplateRows: rows,
        gridColumnGap: gap ? false : (0, _props.numberToPx)(columnGap),
        gridGap: (0, _props.numberToPx)(gap),
        gridRowGap: gap ? false : (0, _props.numberToPx)(rowGap),
        gridTemplate: template,
        gridTemplateAreas: (0, _layout.formatTemplateAreas)(templateAreas),
        justifyItems: center ? 'center' : justifyItems
      }; // filters out keys with false(sy) values

      return (0, _pickBy2["default"])(inlineClasses);
    });

    var context = props.context,
        themeId = props.themeId,
        theme = props.theme,
        themeOverrides = props.themeOverrides;
    _this.state = {
      composedTheme: (0, _themes.composeTheme)((0, _themes.addThemeId)(theme || context.theme, themeId), (0, _themes.addThemeId)(themeOverrides, themeId), context.ROOT_THEME_API)
    };
    return _this;
  }

  _createClass(GridBase, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      if (prevProps !== this.props) {
        (0, _themes.didThemePropsChange)(prevProps, this.props, this.setState.bind(this));
      }
    } // creates obj passed Base component's inline styles (see render)

  }, {
    key: "renderChildren",
    value: function renderChildren(theme) {
      return _react["default"].Children.map(this.props.children, function (child) {
        if (child.type.displayName === 'GridItem') {
          return (
            /*#__PURE__*/
            _react["default"].cloneElement(child, {
              theme: theme
            })
          );
        }

        return child;
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          themeId = _this$props2.themeId,
          className = _this$props2.className;

      var inlineGrid = this._assembleInlineGrid();

      var theme = this.state.composedTheme[themeId];
      return (
        /*#__PURE__*/
        _react["default"].createElement(_Base.Base, {
          className: className,
          stylesToAdd: theme,
          activeClasses: ['container'],
          inlineStyles: inlineGrid
        }, this.renderChildren(theme))
      );
    }
  }]);

  return GridBase;
}(_react.Component);

_defineProperty(GridBase, "displayName", 'Grid');

_defineProperty(GridBase, "defaultProps", {
  columnGap: 5,
  context: (0, _withTheme.createEmptyContext)(),
  gap: 0,
  rowGap: 5,
  templateAreas: [],
  theme: null,
  themeId: _.IDENTIFIERS.GRID,
  themeOverrides: {}
});

var Grid = (0, _withTheme.withTheme)(GridBase);
exports.Grid = Grid;
//# sourceMappingURL=Grid.js.map