"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.BubbleSkin = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _props = require("../../utils/props");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BubbleSkin = function BubbleSkin(props) {
  var _ref;

  var arrowRelativeToTip = props.arrowRelativeToTip,
      noArrow = props.noArrow,
      theme = props.theme,
      themeId = props.themeId;
  var autoWidthClass = arrowRelativeToTip ? theme[themeId].hasAutoWidth : null;
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", _extends({
      ref: props.rootRef
    }, (0, _props.pickDOMProps)(props), {
      className: (0, _classnames["default"])([props.className, theme[themeId].root, props.isOpeningUpward ? theme[themeId].openUpward : null, props.isCentered ? theme[themeId].isCentered : null, props.isTransparent ? theme[themeId].transparent : null, props.isFloating ? theme[themeId].isFloating : null, props.isHidden ? theme[themeId].isHidden : null, noArrow ? theme[themeId].noArrow : null]),
      style: props.position && (_ref = {}, _defineProperty(_ref, props.isOpeningUpward ? 'bottom' : 'top', props.position.positionY), _defineProperty(_ref, "left", props.position.positionX), _defineProperty(_ref, "width", props.position.width), _ref)
    }),
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: (0, _classnames["default"])([theme[themeId].bubble, autoWidthClass]),
      "data-bubble-container": "true"
    }, props.children, arrowRelativeToTip &&
    /*#__PURE__*/
    _react["default"].createElement("span", {
      className: theme[themeId].arrow,
      "data-bubble-arrow": noArrow ? undefined : true
    })), !arrowRelativeToTip &&
    /*#__PURE__*/
    _react["default"].createElement("span", {
      className: theme[themeId].arrow,
      "data-bubble-arrow": noArrow ? undefined : true
    }))
  );
};

exports.BubbleSkin = BubbleSkin;
//# sourceMappingURL=BubbleSkin.js.map