"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.DropdownSkin = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _Options = require("../../components/Options");

var _OptionsSkin = require("./OptionsSkin");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// external libraries
// components
// skins
var DropdownSkin = function DropdownSkin(props) {
  var theme = props.theme,
      themeId = props.themeId,
      setMouseOverItems = props.setMouseOverItems,
      setMouseOverRoot = props.setMouseOverRoot;
  var themeApi = theme[themeId];
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: (0, _classnames["default"])([props.className, themeApi.dropdown]),
      onMouseEnter: function onMouseEnter() {
        return setMouseOverRoot(true);
      },
      onMouseLeave: function onMouseLeave() {
        return setMouseOverRoot(false);
      },
      ref: props.rootRef
    },
    /*#__PURE__*/
    _react["default"].createElement("div", {
      role: "presentation",
      "aria-hidden": true,
      className: themeApi.label,
      onClick: props.onLabelClick
    }, props.label),
    /*#__PURE__*/
    _react["default"].createElement(_Options.Options, {
      isFloating: true,
      isOpen: props.isOpen,
      isOpeningUpward: props.isOpeningUpward,
      noOptionsArrow: props.noArrow,
      noSelectedOptionCheckmark: true,
      onChange: props.onItemSelected,
      options: props.items,
      optionsMaxHeight: props.optionsMaxHeight,
      optionHeight: props.optionHeight,
      optionsRef: props.optionsRef,
      optionRenderer: props.optionRenderer,
      selectedOption: props.activeItem,
      setMouseIsOverOptions: setMouseOverItems,
      skin: _OptionsSkin.OptionsSkin,
      theme: props.theme
    }))
  );
};

exports.DropdownSkin = DropdownSkin;
//# sourceMappingURL=DropdownSkin.js.map