"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FormFieldSkin = FormFieldSkin;

var _react = _interopRequireWildcard(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _PopOver = require("../../components/PopOver");

var _SimpleFormField = require("../../themes/simple/SimpleFormField");

var _hooks = require("../../utils/hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function FormFieldSkin(props) {
  var updateOnRefChanges = (0, _hooks.manageRef)(props.formFieldRef);
  var isFormFieldFocused = (0, _hooks.handleRefState)(props.formFieldRef, {
    on: 'focus',
    off: 'blur'
  });
  var isFormFieldHovered = (0, _hooks.handleRefState)(props.formFieldRef, {
    on: 'mouseenter',
    off: 'mouseleave'
  });
  var hasError = props.error != null;
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: (0, _classnames["default"])([props.className, props.theme[props.themeId].root, props.disabled ? props.theme[props.themeId].disabled : null, props.error ? props.theme[props.themeId].errored : null]),
      style: props.themeVariables
    }, props.label &&
    /*#__PURE__*/
    _react["default"].createElement("label", {
      role: "presentation",
      "aria-hidden": true,
      className: props.theme[props.themeId].label,
      onClick: props.focusChild
    }, props.label),
    /*#__PURE__*/
    _react["default"].createElement(_PopOver.PopOver, {
      visible: props.isErrorShown === true || props.isErrorHidden !== true && hasError && (props.isShowingErrorOnFocus && isFormFieldFocused || props.isShowingErrorOnHover && isFormFieldHovered),
      content: props.error,
      themeVariables: _objectSpread({
        '--rp-pop-over-bg-color': "var(".concat(_SimpleFormField.SimpleFormFieldVariables.errorColor)
      }, props.themeVariables),
      placement: "bottom",
      popperOptions: {
        modifiers: [{
          name: 'flip',
          enabled: false
        }]
      },
      duration: [300, 0]
    },
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: props.theme[props.themeId].inputWrapper
    }, props.render(updateOnRefChanges))))
  );
}
//# sourceMappingURL=FormFieldSkin.js.map