"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InfiniteScrollSkin = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// external libraries
var InfiniteScrollSkin = function InfiniteScrollSkin(_ref) {
  var className = _ref.className,
      data = _ref.data,
      error = _ref.error,
      hasMoreData = _ref.hasMoreData,
      isLoading = _ref.isLoading,
      renderItems = _ref.renderItems,
      scrollContainerRef = _ref.scrollContainerRef,
      theme = _ref.theme,
      themeId = _ref.themeId;
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", {
      ref: scrollContainerRef,
      className: (0, _classnames["default"])([className, theme[themeId].root])
    }, renderItems({
      data: data,
      error: error,
      hasMoreData: hasMoreData,
      isLoading: isLoading,
      theme: theme[themeId]
    }))
  );
};

exports.InfiniteScrollSkin = InfiniteScrollSkin;
//# sourceMappingURL=InfiniteScrollSkin.js.map