"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.InputSkin = void 0;

var _isFunction2 = _interopRequireDefault(require("lodash/isFunction"));

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _FormField = require("../../components/FormField");

var _props = require("../../utils/props");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var InputSkin = function InputSkin(props) {
  var renderInput = function renderInput(setFormFieldRef) {
    return (
      /*#__PURE__*/
      _react["default"].createElement("input", _extends({
        ref: setFormFieldRef
      }, (0, _props.pickDOMProps)(props), {
        className: (0, _classnames["default"])([props.theme[props.themeId].input, props.disabled ? props.theme[props.themeId].disabled : null, !props.hideErrorState && (props.error || props.showErrorState) ? props.theme[props.themeId].errored : null])
      }))
    );
  };

  var useSelectionRenderer = function useSelectionRenderer(setFormFieldRef, option) {
    return (
      /*#__PURE__*/
      _react["default"].createElement("div", {
        className: props.theme[props.themeId].customValueWrapper
      }, renderInput(setFormFieldRef),
      /*#__PURE__*/
      _react["default"].createElement("div", {
        className: props.theme[props.themeId].customValueBlock
      }, option && props.selectionRenderer && props.selectionRenderer(option)))
    );
  };

  var render = function render(setFormFieldRef) {
    // check if user has passed render prop "selectionRenderer"
    var hasSelectionRenderer = props.selectionRenderer && (0, _isFunction2["default"])(props.selectionRenderer);

    if (hasSelectionRenderer) {
      return useSelectionRenderer(setFormFieldRef, props.selectedOption);
    }

    return renderInput(setFormFieldRef);
  };

  return (
    /*#__PURE__*/
    _react["default"].createElement(_FormField.FormField, {
      className: props.className,
      disabled: props.disabled,
      label: props.label,
      error: props.error,
      isShowingErrorOnHover: props.isShowingErrorOnHover,
      isShowingErrorOnFocus: props.isShowingErrorOnFocus,
      formFieldRef: props.inputRef,
      theme: props.theme,
      render: render,
      themeVariables: props.themeVariables
    })
  );
};

exports.InputSkin = InputSkin;
//# sourceMappingURL=InputSkin.js.map