"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LinkSkin = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// external libraries
var LinkSkin = function LinkSkin(props) {
  var label = props.label,
      isUnderlined = props.isUnderlined,
      hasIconBefore = props.hasIconBefore,
      hasIconAfter = props.hasIconAfter,
      onClick = props.onClick,
      className = props.className,
      theme = props.theme,
      themeId = props.themeId,
      underlineOnHover = props.underlineOnHover;
  return (
    /*#__PURE__*/
    _react["default"].createElement("span", {
      role: "presentation",
      "aria-hidden": true,
      className: (0, _classnames["default"])([className, theme[themeId].root, hasIconBefore ? theme[themeId].withIconBefore : null, hasIconAfter ? theme[themeId].withIconAfter : null, isUnderlined && !underlineOnHover ? theme[themeId].underlined : null, underlineOnHover ? theme[themeId].underlinedOnHover : null]),
      onClick: onClick
    }, label)
  );
};

exports.LinkSkin = LinkSkin;
//# sourceMappingURL=LinkSkin.js.map