"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PasswordInputSkin = void 0;

var _classnames = _interopRequireDefault(require("classnames"));

var _react = _interopRequireDefault(require("react"));

var _Input = require("../../components/Input");

var _PasswordInput = require("../../components/PasswordInput");

var _SimplePasswordInput = require("../../themes/simple/SimplePasswordInput");

var _hooks = require("../../utils/hooks");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function getPopOverBgColorForState(state) {
  switch (state) {
    case _PasswordInput.PasswordInput.STATE.ERROR:
    case _PasswordInput.PasswordInput.STATE.INSECURE:
      return "var(".concat(_SimplePasswordInput.SimplePasswordInputVariables.errorColor, ")");

    case _PasswordInput.PasswordInput.STATE.WEAK:
      return "var(".concat(_SimplePasswordInput.SimplePasswordInputVariables.warningColor, ")");

    case _PasswordInput.PasswordInput.STATE.STRONG:
      return "var(".concat(_SimplePasswordInput.SimplePasswordInputVariables.successColor, ")");

    case _PasswordInput.PasswordInput.STATE.DEFAULT:
    default:
      return 'var(--rp-pop-over-bg-color)';
  }
}

var PasswordInputSkin = function PasswordInputSkin(props) {
  var className = props.className,
      error = props.error,
      debounceDelay = props.debounceDelay,
      isShowingTooltipOnFocus = props.isShowingTooltipOnFocus,
      isShowingTooltipOnHover = props.isShowingTooltipOnHover,
      isTooltipOpen = props.isTooltipOpen,
      score = props.score,
      state = props.state,
      theme = props.theme,
      themeId = props.themeId,
      tooltip = props.tooltip,
      useDebounce = props.useDebounce,
      value = props.value,
      inputProps = _objectWithoutProperties(props, ["className", "error", "debounceDelay", "isShowingTooltipOnFocus", "isShowingTooltipOnHover", "isTooltipOpen", "score", "state", "theme", "themeId", "tooltip", "useDebounce", "value"]);

  var hasInitialValueChanged = useDebounce ? (0, _hooks.useDebouncedValueChangedIndicator)(value, debounceDelay) : true;
  var hasTooltip = hasInitialValueChanged && tooltip != null;
  var stateColor = getPopOverBgColorForState(state);
  var isErrorState = state === _PasswordInput.PasswordInput.STATE.ERROR;
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: (0, _classnames["default"])([theme[themeId].root, theme[themeId][state], className])
    },
    /*#__PURE__*/
    _react["default"].createElement(_Input.Input, _extends({}, inputProps, {
      error: hasTooltip ? tooltip : null,
      showErrorState: hasTooltip && isErrorState,
      hideErrorState: !isErrorState,
      value: value,
      type: "password",
      themeVariables: {
        '--rp-pop-over-bg-color': stateColor
      }
    })),
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: theme[themeId].indicator
    },
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: theme[themeId].score,
      style: {
        width: "".concat((score || 0) * 100, "%")
      }
    })))
  );
}; // Static Properties


exports.PasswordInputSkin = PasswordInputSkin;
PasswordInputSkin.displayName = 'PasswordInputSkin';
//# sourceMappingURL=PasswordInputSkin.js.map