"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.PopOverSkin = PopOverSkin;

var _isString2 = _interopRequireDefault(require("lodash/isString"));

var _react = _interopRequireDefault(require("@tippyjs/react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _popper = _interopRequireDefault(require("popper.js"));

var _react2 = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var PopOverWrapper =
/*#__PURE__*/
(0, _react2.forwardRef)(function (props, ref) {
  return (
    /*#__PURE__*/
    _react2["default"].createElement("span", {
      className: props.className,
      ref: ref
    }, props.children)
  );
});

function PopOverSkin(props) {
  var _popperOptions$modifi;

  var allowHTML = props.allowHTML,
      children = props.children,
      className = props.className,
      content = props.content,
      contentClassName = props.contentClassName,
      popperOptions = props.popperOptions,
      theme = props.theme,
      themeId = props.themeId,
      themeOverrides = props.themeOverrides,
      themeVariables = props.themeVariables,
      visible = props.visible,
      tippyProps = _objectWithoutProperties(props, ["allowHTML", "children", "className", "content", "contentClassName", "popperOptions", "theme", "themeId", "themeOverrides", "themeVariables", "visible"]);

  var hasContent =
  /*#__PURE__*/
  _react2["default"].isValidElement(content) || (0, _isString2["default"])(content) && content !== '';
  return (
    /*#__PURE__*/
    _react2["default"].createElement(_react["default"], _extends({
      offset: [0, 14]
    }, tippyProps, {
      visible: hasContent ? visible : false,
      content: (0, _isString2["default"])(content) && allowHTML ?
      /*#__PURE__*/
      _react2["default"].createElement("span", {
        dangerouslySetInnerHTML: {
          __html: content
        }
      }) : content,
      className: (0, _classnames["default"])([theme[themeId].root, className]),
      theme: "polymorph",
      plugins: [{
        // Makes it possible to pass themeVariables props to PopOvers
        name: 'cssVariables',
        defaultValue: {},
        fn: function fn(instance) {
          return {
            onAfterUpdate: function onAfterUpdate() {
              var cssVariables = instance.props.cssVariables;
              Object.keys(cssVariables).forEach(function (key) {
                instance.popper.style.setProperty(key, cssVariables[key]);
              });
            }
          };
        }
      }],
      popperOptions: _objectSpread(_objectSpread({}, popperOptions), {}, {
        modifiers: [{
          name: 'computeStyles',
          options: {
            // Necessary to avoid sub-pixel rendering issues with arrows
            gpuAcceleration: false // true by default

          }
        }, {
          name: 'preventOverflow',
          options: {
            // Keep a 4px distance from the viewport edges
            padding: 4
          }
        }].concat((_popperOptions$modifi = popperOptions.modifiers) !== null && _popperOptions$modifi !== void 0 ? _popperOptions$modifi : [])
      }),
      cssVariables: themeVariables
    }),
    /*#__PURE__*/
    _react2["default"].createElement(PopOverWrapper, {
      className: contentClassName
    }, children))
  );
}
//# sourceMappingURL=PopOverSkin.js.map