"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RadioSkin = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _props = require("../../utils/props");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var RadioSkin = function RadioSkin(props) {
  var theme = props.theme,
      themeId = props.themeId,
      className = props.className,
      disabled = props.disabled,
      selected = props.selected,
      onChange = props.onChange,
      label = props.label;
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", {
      role: "presentation",
      "aria-hidden": true,
      className: (0, _classnames["default"])([className, theme[themeId].root, disabled ? theme[themeId].disabled : null, selected ? theme[themeId].selected : null]),
      onClick: function onClick(event) {
        if (!disabled && onChange) {
          onChange(!selected, event);
        }
      }
    },
    /*#__PURE__*/
    _react["default"].createElement("input", _extends({}, (0, _props.pickDOMProps)(props), {
      className: theme[themeId].input,
      type: "radio"
    })),
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: (0, _classnames["default"])([theme[themeId].circle, selected ? theme[themeId].selected : null])
    }), label ?
    /*#__PURE__*/
    _react["default"].createElement("label", {
      className: theme[themeId].label
    }, label) : null)
  );
};

exports.RadioSkin = RadioSkin;
//# sourceMappingURL=RadioSkin.js.map