"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SwitchSkin = void 0;

var _react = _interopRequireDefault(require("react"));

var _classnames = _interopRequireDefault(require("classnames"));

var _props = require("../../utils/props");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var SwitchSkin = function SwitchSkin(props) {
  var theme = props.theme,
      themeId = props.themeId;
  return (
    /*#__PURE__*/
    _react["default"].createElement("div", {
      role: "presentation",
      "aria-hidden": true,
      className: (0, _classnames["default"])([props.className, theme[themeId].root, props.disabled ? theme[themeId].disabled : null, props.checked ? theme[themeId].checked : null]),
      onClick: function onClick(event) {
        if (!props.disabled && props.onChange) {
          props.onChange(!props.checked, event);
        }
      }
    },
    /*#__PURE__*/
    _react["default"].createElement("input", _extends({}, (0, _props.pickDOMProps)(props), {
      className: theme[themeId].input,
      readOnly: true,
      type: "checkbox"
    })),
    /*#__PURE__*/
    _react["default"].createElement("div", {
      className: (0, _classnames["default"])([theme[themeId]["switch"], props.checked ? theme[themeId].checked : null])
    },
    /*#__PURE__*/
    _react["default"].createElement("span", {
      className: theme[themeId].thumb
    })), props.label ?
    /*#__PURE__*/
    _react["default"].createElement("label", {
      className: theme[themeId].label
    }, props.label) : null)
  );
};

exports.SwitchSkin = SwitchSkin;
//# sourceMappingURL=SwitchSkin.js.map