"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatTemplateAreas = exports.composeBaseStyles = void 0;

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// the baseStyles obj will be composed with the stylesToAdd obj
// activeClasses is an array of the classes within stylesToAdd
// that should be added to baseStyles
var composeBaseStyles = function composeBaseStyles(baseStyles) {
  var stylesToAdd = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var activeClasses = arguments.length > 2 ? arguments[2] : undefined;

  if (!activeClasses || !activeClasses.length) {
    return baseStyles;
  }

  var composedBase = _objectSpread({}, baseStyles);

  activeClasses.forEach(function (className) {
    if (Object.hasOwnProperty.call(stylesToAdd, className) && stylesToAdd[className]) {
      composedBase.base += " ".concat(stylesToAdd[className]);
    }
  });
  return composedBase;
};

exports.composeBaseStyles = composeBaseStyles;

var formatTemplateAreas = function formatTemplateAreas(areas) {
  if (!areas || !areas.length) {
    return;
  }

  return areas.reduce(function (template, row, index) {
    if (!index) {
      return "'".concat(row, "'");
    }

    return "".concat(template, " '").concat(row, "'");
  }, '');
};

exports.formatTemplateAreas = formatTemplateAreas;
//# sourceMappingURL=layout.js.map