"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getDisplayName = exports.hasProperty = exports.numberToPx = exports.composeFunctions = exports.pickDOMProps = void 0;

var _filterReactDomProps = _interopRequireDefault(require("filter-react-dom-props"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// filters out / prevents invalid props from being rendered to the dom
// which would generate an error/warning
var pickDOMProps = _filterReactDomProps["default"];
exports.pickDOMProps = pickDOMProps;

var composeFunctions = function composeFunctions() {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return function () {
    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return fns.forEach(function (fn) {
      return fn && fn.apply(void 0, args);
    });
  };
};

exports.composeFunctions = composeFunctions;

var numberToPx = function numberToPx(val) {
  return typeof val === 'number' ? "".concat(val, "px") : val;
};

exports.numberToPx = numberToPx;

var hasProperty = function hasProperty(obj, property) {
  return Object.prototype.hasOwnProperty.call(obj, property);
};

exports.hasProperty = hasProperty;

var getDisplayName = function getDisplayName(Component) {
  return Component.displayName || Component.name;
};

exports.getDisplayName = getDisplayName;
//# sourceMappingURL=props.js.map